<?php

/**
 * Webinterface for squidwall
 *
 * ctime: 2006-04-08
 * mtime: 2006-05-27
 *
 * Beschreibung:
 * - hier landen alle Funktionen
 */

/* Funktion zum Beenden einer Anfrage */
function print_foot() {
	echo "</body></html>";
	exit;
}

function fatal_error($a="") {
	global $P_INT;
	echo $a;
	print_foot();
}

function my_rename($dir, $file, $pold, $pnew) {
	global $changed;
	rename($dir."/"."$pold$file", $dir."/"."$pnew$file");
	$changed=1;
	return;
}

/* for my_edit_hosts() */
function my_touch($dir, $file, $p) {
	global $changed;
	touch($dir."/"."$p$file");
	$changed=1;
	return;
}

/* touches, renames files as wanted */
function my_edit_acls($dir2save, $filename) {
	global $changed, $group;
	
	$f=file($filename);
	$sel_access_prefix = array ("+", "?", "-");
	
	for($i=0; isset($f[$i]); $i++) {
		$e=chop($f[$i]);
		$x=$_POST["$group$i"];    /* die zahl: 1..3 -> 0..2 */
		$c=$sel_access_prefix[$x-1]; /* '+' '?' '-' */
		$changed=0;
		
		switch ($c) {
		case "+":
			if (is_file($dir2save . "/?" . $e)) {
				my_rename($dir2save, "$e", "?", "+");
				break;
			}
			if (is_file($dir2save . "/-" . $e)) {
				my_rename($dir2save, "$e", "-", "+");
				break;
			}
			if (!is_file($dir2save . "/+" . $e)) {
				my_touch($dir2save, "$e", "+");
				break;
			}
			break;
		case "?":
			if (is_file($dir2save . "/+" . $e)) {
				my_rename($dir2save, "$e", "+", "?");
				break;
			}
			if (is_file($dir2save . "/-" . $e)) {
				my_rename($dir2save, "$e", "-", "?");
				break;
			}
			if (!is_file($dir2save . "/?" . $e)) {
				my_touch($dir2save, "$e", "?");
			}
			break;
		case "-":
			if (is_file($dir2save . "/?" . $e)) {
				my_rename($dir2save, "$e", "?", "-");
				break;
			}
			if (is_file($dir2save . "/+" . $e)) {
				my_rename($dir2save, "$e", "+", "-");
				break;
			}
			if (!is_file($dir2save . "/-" . $e)) {
				my_touch($dir2save, "$e", "-");
			}
			break;
		default:
			break;
		}
		
		/* die Datei '!' wird durch squidwall geprft */
		if ($changed == 1) {
			touch("$dir2save/!");
		}
	}
}

/**
 * touches or renames files as wanted
 */
function my_edit_options($path, $name) {
	if (is_file($path . "/+" . $name)) {
		my_rename($path, $name, "+", "?");
	}
	if (is_file($path . "/-" . $name)) {
		my_rename($path, $name, "-", "?");
	}
	if (!is_file($path . "/?" . $name)) {
		my_touch($path, $name, "?");
	}
}

/**
 * edit/create some file from textarea input
 */
function my_edit_filters($filename) {
	$defs = $_POST['defs'];
	$defs = str_replace("\r\n", "\n", $defs);
	$defs = str_replace("\"", '"', $defs);
	$defs = str_replace("\\", "", $defs);
	$f=fopen("$filename","w");
	fwrite($f, $defs, strlen($defs));
	fclose($f);
	$f = dirname($filename) . "/!";
	touch($f);
}

/**
 * edit/create some file from textarea input
 */
function my_edit_defs($filename) {
	$defs = $_POST['defs'];
	$defs = str_replace("\r\n", "\n", $defs);
	$defs = str_replace("\"", '"', $defs);
	$defs = str_replace("\\", "", $defs);
	$f=fopen("$filename","w");
	fwrite($f, $defs, strlen($defs));
	fclose($f);
}

/**
 * init_defs(path,array)
 */
function init_defs($path, &$array) {
	$dh=opendir($path);
	while ($file = readdir($dh)) {
		if (!is_file("$path/$file")) { continue; }
		$array[] = $file;
	}
	closedir($dh);
	
	if (!is_array($array)) {
		fatal_error("
		<h3>Not enough users or hosts @ <u>$path</u> defined !</h3><p>
		Just do something like:
<pre>
For Host Setup:
echo \"host1\" >> $path/room1
echo \"host2\" >> $path/room1
echo \"ip3\"   >> $path/room1
echo \"ip4\"   >> $path/room2
echo \"hostX\" >> $path/roomX

For User Setup:
echo \"-\"     >> $path/squid-default-user
echo \"user1\" >> $path/room1
echo \"user2\" >> $path/room1
echo \"user3\" >> $path/room1
</pre>
		");
	}

	sort($array);
	reset($array);
}

/**
 * init_filterdir(path,array)
 *
 * @param path   eg $P_BFILTER
 * @param array  eg $BF
 */
function init_filterdir(&$path, &$array) {
	if (!is_dir($path)) return;
	$dh=opendir($path);
	while ($file = readdir($dh)) {
		if (!is_file("$path/$file")) { continue; }
		if ($file == "!" || $file == "@" || $file == "README") {
			continue;
		}
		$array[] = $file;
	}
	closedir($dh);
	
	if (count($array)) {
		sort($array);
		reset($array);
	}
}

/**
 * init_cachedir(path,array)
 *
 * @param path   eg $P_CACHE
 * @param array  eg $x
 */
function init_cachedir(&$path, &$array) {
	if (!is_dir($path)) return;
	$dh=opendir($path);
	while ($file = readdir($dh)) {
		if (!is_file("$path/$file")) { continue; }
		if ($file == "!") { continue; }
		$array[] = $file;
	}
	closedir($dh);

	if (count($array)) {
		sort($array);
		reset($array);
	}
}

/**
 * init_redirects(path,array)
 *
 * @param path         path of the redirect directory
 * @param array_files  this array is filled with the found symlink names
 * @param array_links  this array gets the destination of the symlinks
 */
function init_redirects(&$path, &$array_files, &$array_links) {
	if (!is_dir($path)) return;
	$dh=opendir($path);
	while ($file = readdir($dh)) {
		if (!is_link("$path/$file")) { continue; }
		if ($file == "!" || $file == "@" || $file == "README") {
			continue;
		}
		$array_files[] = $file;
		$array_links[] = readlink("$path/$file");
	}
	closedir($dh);

//	for ($i=0; isset($array_files[$i]); $i++) {
//		echo $array_files[$i] . " -> " . $array_links[$i] . "<br>";
//	}
}

/**
 * check_redirect(path,name,dest)
 *
 * @param path    path of the redirect directory
 * @param name    name of some redirect
 * @param dest    destination of some redirect
 * @param i       redirect number, which is affected
 */
function check_redirect($path, $name, $dest) {
	global $check_chg, $check_del, $i;
	global $REDIR_names, $REDIR_links;

	if (!is_dir($path)) return;

	$n=$REDIR_names[$i];
	$l=$REDIR_links[$i];

	if ($name == "" || $dest == "") {
		/* we have to delete some redirect */
		echo "$check_del $n<br>";
		unlink("$path/$n");
		touch("$path/!");
		return;
	}

	/* check, if the link has changed */
	if ($n != $name || $l != $dest) {
		echo "$check_chg $name -> $dest<br>";
		unlink("$path/$n");
		symlink("$dest", "$path/$name");
		touch("$path/!");
	}
}

/**
 * add_redirect(path,name,dest)
 *
 * @param path    path of the redirect directory
 * @param name    name of some redirect
 * @param dest    destination of some redirect
 */
function add_redirect($path, $name, $dest) {
	global $check_add;

	if (!is_dir($path)) return;

	if ($name == "") return;
	if ($dest == "") return;

	/* add new link */
	echo "$check_add $path/$name -> $dest<br>";
	symlink("$dest", "$path/$name");
	touch("$path/!");
}

/**
 * chg_user(name,pass,admin,oldname)
 *
 * @param name    name of the new user
 * @param pass    new password
 * @param admin   should the user have adminrights
 * @param oldname old username, which should be in the db
 */
function chg_user($name, $pass, $admin, $oldname) {
	global $F_AUTH;

	if (!is_writeable($F_AUTH)) return;
	if ($oldname == "") return;
	if ($name == "") return;
	if ($pass == "") return;

	/* add new link */
	$db_old=file($F_AUTH);
	for ($i=0; $i < count($db_old); $i++) { /* fr alle zeilen */
		if ($db_old[$i][0] == '#') { /* skip comments */
			$db_new[] = $db_old[$i]; continue;
		}
		list($user, $hash, $perms) = explode(':', $db_old[$i]);

		/* skip invalid lines */
		if (!isset($user)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($hash)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($perms)) { $db_new[] = $db_old[$i]; continue; }
		$perms=trim($perms);

		/* this line should change! */
		if ($user == $oldname) {
			$hash = sha1("$name:$pass");
			if (isset($admin)) { $type="a"; } else { $type="u"; }
			$x = "$name:$hash:$type\n";
			$db_new[] = $x;
			continue;
		}
		$db_new[] = $db_old[$i];
	}
	
	$f=fopen("$F_AUTH","w");
	for ($i=0; $i < count($db_new); $i++) {
		fwrite($f, $db_new[$i], strlen($db_new[$i]));
	}
	fclose($f);
}

/**
 * add_user(name,pass,admin)
 *
 * @param name    name of the new user
 * @param pass    new password
 * @param admin   should the user have adminrights
 */
function add_user($name, $pass, $admin) {
	global $F_AUTH;

	if (!is_writeable($F_AUTH)) return;
	if ($name == "") return;
	if ($pass == "") return;

	/* add new link */
	$db_old=file($F_AUTH);
	for ($i=0; $i < count($db_old); $i++) { /* fr alle zeilen */
		if ($db_old[$i][0] == '#') { /* skip comments */
			$db_new[] = $db_old[$i]; continue;
		}
		list($user, $hash, $perms) = explode(':', $db_old[$i]);

		/* skip invalid lines */
		if (!isset($user)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($hash)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($perms)) { $db_new[] = $db_old[$i]; continue; }
		$perms=trim($perms);

		/* this line should change! */
		if ($user == $name) {
			$hash = sha1("$name:$pass");
			if (isset($admin)) { $type="a"; } else { $type="u"; }
			$x = "$name:$hash:$type\n";
			$db_new[] = $x;
			$user_added=1;
			continue;
		}

		$db_new[] = $db_old[$i];
	}
	
	if (!isset($user_added)) {
		// echo "add_user([$name], [$pass], [$admin]) APPEND<br>";
		/* append to file, if a user is added */
		$hash = sha1("$name:$pass");
		if (isset($admin)) { $type="a"; } else { $type="u"; }
		$x = "$name:$hash:$type\n";
		$f=fopen("$F_AUTH","a");
		fwrite($f, $x, strlen($x));
	} else {
		// echo "add_user([$name], [$pass], [$admin]) REWRITE<br>";
		/* rewrite whole file, if a user has changed */
		$f=fopen("$F_AUTH","w");
		for ($i=0; $i < count($db_new); $i++) {
			fwrite($f, $db_new[$i], strlen($db_new[$i]));
		}
	}
	fclose($f);
}

/**
 * del_user(name)
 *
 * @param name    name of the user to delete
 */
function del_user($name) {
	global $F_AUTH;

	if (!is_writeable($F_AUTH)) return;
	if ($name == "") return;

	/* add new link */
	$db_old=file($F_AUTH);
	for ($i=0; $i < count($db_old); $i++) { /* fr alle zeilen */
		if ($db_old[$i][0] == '#') { /* skip comments */
			$db_new[] = $db_old[$i]; continue;
		}
		list($user, $hash, $perms) = explode(':', $db_old[$i]);

		/* skip invalid lines */
		if (!isset($user)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($hash)) { $db_new[] = $db_old[$i]; continue; }
		if (!isset($perms)) { $db_new[] = $db_old[$i]; continue; }
		$perms=trim($perms);

		/* this line should change! */
		if ($user == $name) { continue; }
		$db_new[] = $db_old[$i];
	}

	$f=fopen("$F_AUTH","w");
	for ($i=0; $i < count($db_new); $i++) {
		fwrite($f, $db_new[$i], strlen($db_new[$i]));
	}
	fclose($f);
}

/**
 * my_isset(var,val)
 */
function my_isset(&$variable, &$value) {
	return (($variable & $value) == $value);
}

/**
 * get_filter_files(array,cfgline)
 * - ignoriert README, @, !
 * - liest 
 */
function get_filter_files(&$array, $line) {
	echo "line=($line)<br>";
	/**
	 * +p,file1,file2 -> only these two
	 * +p -> all files
	 */
	if ($line[2] == ',') {
		/* only the listed files */
		echo "x: ,<br>";
	}
	/* alle hckchen werden gesetzt */
}

/**
 * read_reg_options(filepath)
 *
 * @param filepath - aus dieser datei sollen die optionen gelesen werden
 */
$ropt_1=1; $ropt_2=2; $ropt_3=4; $ropt_4=8; $ropt_5=16; $ropt_6=32;
function read_reg_options($filepath) {
	global $reg_options;

	if (filesize($filepath) == 0) {
	  return;
	}
	
	$f=file($filepath);
	
	/* options for the regular expressions of squidwall
	 *
	 * cflags for regcomp(3)
	 *  REG_EXTENDED
	 *  REG_ICASE
	 *  REG_NOSUB
	 *  REG_NEWLINE
	 *
	 * eflags for regexec(3)
	 *  REG_NOTBOL
	 *  REG_NOTEOL
	 */
	
	for($i=0; isset($f[$i]); $i++) {
		$line=chop($f[$i]);
		switch ($line[0]) {
		case '+':
			switch ($line[1]) {
				case 'REG_EXTENDED':
					$reg_options |= $opt_1;
					break;
				case 'REG_ICASE':
					$reg_options |= $opt_2;
					break;
				case 'REG_NOSUB':
					$reg_options |= $opt_3;
					break;
				case 'REG_NEWLINE':
					$reg_options |= $opt_4;
					break;
				case 'REG_NOTBOL':
					$reg_options |= $opt_5;
					break;
				case 'REG_NOTEOL':
					$reg_options |= $opt_6;
					break;
			}
			break;
		case '-':
			switch ($line[1]) {
				case 'REG_EXTENDED':
					$reg_options &= ~$opt_1;
					break;
				case 'REG_ICASE':
					$reg_options &= ~$opt_2;
					break;
				case 'REG_NOSUB':
					$reg_options &= ~$opt_3;
					break;
				case 'REG_NEWLINE':
					$reg_options &= ~$opt_4;
					break;
				case 'REG_NOTBOL':
					$reg_options &= ~$opt_5;
					breaK;
				case 'REG_NOTEOL':
					$reg_options &= ~$opt_6;
					break;
			}
			break;
		}
	}
	// echo "reg_options = $reg_options<br>";
}

/**
 * read_options(filepath)
 *
 * @param path - file with the filtering options
 */
$opt_p=1;   $opt_c=2;    $opt_C=4;    $opt_u=8;
$opt_U=16;  $opt_m=32;   $opt_s=64;   $opt_b=128;
$opt_B=256; $opt_a=512;  $opt_w=1024; $opt_W=2048;
$opt_V=4096;
function read_options($filepath) {
	global $options;
	global	$P_BFILTER, $P_BCFILTER, $P_BRFILTER,
		$P_PFILTER, $P_CFILTER, $P_CRFILTER,
		$P_UFILTER, $P_URFILTER,
		$P_MFILTER, $P_SFILTER,
		$P_WFILTER, $P_WRFILTER;

	if (filesize($filepath) == 0) {
		return;
	}
	
	$f=file($filepath);
	
	/* get old values
	 *
	 * p => phrase filter
	 * c => content filter
	 * C => content regex filter
	 *
	 * u => blacklist (url)
	 * U => blacklist (regex @ url)
	 * m => url blacklist with md5sums
	 * s => url blacklist with sha1sums
	 *
	 * b => banner filter (url)
	 * B => banner filter (regex @ url)
	 * a => banner filter (regex @ content)
	 *
	 * w => whitelist (url)
	 * W => whitelist (regex @ url)
	 *
	 * V => virus scanning
	 */
	for($i=0; isset($f[$i]); $i++) {
		$line=chop($f[$i]);
		if ($line[0] == '+')
		switch ($line[1]) {
			case 'p':
				$options |= $opt_p;
				get_filter_files($P_PFILTER, $line);
				break;
			case 'c':
				$options |= $opt_c;
				get_filter_files($P_CFILTER, $line);
				break;
			case 'C':
				$options |= $opt_C;
				get_filter_files($P_CRFILTER, $line);
				break;
			case 'u':
				$options |= $opt_u;
				get_filter_files($P_UFILTER, $line);
				break;
			case 'U':
				$options |= $opt_U;
				get_filter_files($P_URFILTER, $line);
				break;
			case 'm':
				$options |= $opt_m;
				get_filter_files($P_MFILTER, $line);
				break;
			case 's':
				$options |= $opt_s;
				get_filter_files($P_SFILTER, $line);
				break;
			case 'b':
				$options |= $opt_b;
				get_filter_files($P_BFILTER, $line);
				break;
			case 'B':
				$options |= $opt_B;
				get_filter_files($P_BRFILTER, $line);
				break;
			case 'a':
				$options |= $opt_a;
				get_filter_files($P_BCFILTER, $line);
				break;
			case 'w':
				$options |= $opt_w;
				get_filter_files($P_WFILTER, $line);
				break;
			case 'W':
				$options |= $opt_W;
				get_filter_files($P_WRFILTER, $line);
				break;
			case 'V':
			  $options |= $opt_V;
			  break;
		}
		
		if ($line[0] == '-')
		switch ($line[1]) {
			case 'p':
				$options &= ~$opt_p; unset($filter_p);
				break;
			case 'c':
				$options &= ~$opt_c; unset($filter_c);
				break;
			case 'C':
				$options &= ~$opt_C; unset($filter_C);
				break;
			case 'u':
				$options &= ~$opt_u; unset($filter_u);
				break;
			case 'U':
				$options &= ~$opt_U; unset($filter_U);
				break;
			case 'm':
				$options &= ~$opt_m; unset($filter_m);
				break;
			case 's':
				$options &= ~$opt_s; unset($filter_s);
				break;
			case 'b':
				$options &= ~$opt_b; unset($filter_b);
				break;
			case 'B':
				$options &= ~$opt_B; unset($filter_B);
				break;
			case 'a':
				$options &= ~$opt_a; unset($filter_a);
				break;
			case 'w':
				$options &= ~$opt_w; unset($filter_w);
				break;
			case 'W':
				$options &= ~$opt_W; unset($filter_W);
				break;
			case 'V':
				$options &= ~$opt_V;
				break;
		} /* switch() */
	} /* for() */
	// echo "options = $options<br>";
}

?>
