<?php

/**
 * see http://www.mcmilk.de/projects/pppd/ for more info
 */

$style="pppd";
echo "<h3>$headline</h3>";

/* Hintergrundfarben */
$h_color="#999999"; /* table head */
$t_color="#888888"; /* total */

$y_color="#aaaaaa"; /* years */
$m_color="#bbbbbb"; /* month */
$w_color="#cccccc"; /* month */
$d_color="#dddddd"; /* daily */
$l_color="#eeeeee"; /* logins */

/* Schriftfarben */
$t_in_font ="#00ff00";
$t_out_font="#dd0000";
$y_in_font ="#00ff00";
$y_out_font="#ee0000";
$m_in_font ="#00ff00";
$m_out_font="#ee0000";
$w_in_font ="#00bb00";
$w_out_font="#dd0000";
$d_in_font ="#00aa00";
$d_out_font="#ee0000";
$l_in_font ="#009900";
$l_out_font="#ff0000";

$name_day   = $msg[$lang]['date']['days'];
$name_month = $msg[$lang]['date']['months'];
$y_name     = $msg[$lang]['date']['year'];
$w_name     = $msg[$lang]['date']['week'];

$b_question = $msg[$lang]['pppd']['bytes'];
$l_question = $msg[$lang]['pppd']['logins'];
$d_question = $msg[$lang]['pppd']['daily'];
$w_question = $msg[$lang]['pppd']['weekly'];
$m_question = $msg[$lang]['pppd']['monthly'];
$y_question = $msg[$lang]['pppd']['yearly'];
$t_question = $msg[$lang]['pppd']['summary'];
$r_in_query = $msg[$lang]['pppd']['downstream'];
$r_out_query= $msg[$lang]['pppd']['upstream'];

if (!isset($_POST['want_bytes']) && !isset($_POST['want_logins']) &&
!isset($_POST['want_daily']) && !isset($_POST['want_weekly']) &&
!isset($_POST['want_monthly']) && !isset($_POST['want_yearly']) &&
!isset($_POST['want_total']) && !isset($_POST['want_in_rate']) &&
!isset($_POST['want_out_rate'])) {
 /* that our default selection */
 //$want_bytes=$want_logins=1;
 //$want_daily=1;
 $want_weekly=$want_monthly=$want_yearly=1;
 $want_total=$want_out_rate=$want_in_rate=1;
}

if (isset($_POST['want_bytes']))    { $want_bytes=1;    }
if (isset($_POST['want_logins']))   { $want_logins=1;   };
if (isset($_POST['want_daily']))    { $want_daily=1;    };
if (isset($_POST['want_weekly']))   { $want_weekly=1;   };
if (isset($_POST['want_monthly']))  { $want_monthly=1;  };
if (isset($_POST['want_yearly']))   { $want_yearly=1;   };
if (isset($_POST['want_total']))    { $want_total=1;    };
if (isset($_POST['want_in_rate']))  { $want_in_rate=1;  };
if (isset($_POST['want_out_rate'])) { $want_out_rate=1; };

if (isset($want_bytes))    { $b_checked="checked"; }
if (isset($want_logins))   { $l_checked="checked"; };
if (isset($want_daily))    { $d_checked="checked"; };
if (isset($want_weekly))   { $w_checked="checked"; };
if (isset($want_monthly))  { $m_checked="checked"; };
if (isset($want_yearly))   { $y_checked="checked"; };
if (isset($want_total))    { $t_checked="checked"; };
if (isset($want_in_rate))  { $ri_checked="checked"; };
if (isset($want_out_rate)) { $ro_checked="checked"; };

$x=$msg[$lang]['button']['reload'];
echo "
<form name=\"pppd\" method=\"POST\" action=\"$P_EXT/main.php?$group\">
$t_open
 <input class=check type=\"checkbox\" name=\"want_bytes\"    $b_checked> $b_question<br>
 <input class=check type=\"checkbox\" name=\"want_logins\"   $l_checked> $l_question<br>
 <input class=check type=\"checkbox\" name=\"want_daily\"    $d_checked> $d_question<br>
 <input class=check type=\"checkbox\" name=\"want_weekly\"   $w_checked> $w_question<br>
 <input class=check type=\"checkbox\" name=\"want_monthly\"  $m_checked> $m_question<br>
 <input class=check type=\"checkbox\" name=\"want_yearly\"   $y_checked> $y_question<br>
 <input class=check type=\"checkbox\" name=\"want_total\"    $t_checked> $t_question<br>
 <input class=check type=\"checkbox\" name=\"want_in_rate\"  $ri_checked> $r_in_query<br>
 <input class=check type=\"checkbox\" name=\"want_out_rate\" $ro_checked> $r_out_query<br>
 <hr size=\"1\">
 <input type=\"submit\" value=\"$x\">
$t_close
</form>
";

function mkit_from_secs($s) {
 $d=$h=$m=0; $str="";
 while ($s>=86400) { $d++; $s-=86400; }
 while ($s>=3600) { $h++; $s-=3600; }
 while ($s>=60)   { $m++; $s-=60; }
 if ($d) $str.=$d ."d ";
 if ($h) $str.=$h ."h ";
 if ($m) $str.=$m ."m ";
 $str.=$s."s";
 return $str;
}

function calc_size($b) {
 $g=(int)($b/(1024*1024*1024)); /* GB */
 $m=(int)($b/(1024*1024)); /* MB */
 $k=(int)($b/1024); /* KB */
 if ($g) return sprintf("%.2f GB", $b/(1024*1024*1024));
 if ($m) return sprintf("%.2f MB", $b/(1024*1024));
 if ($k) return sprintf("%.2f KB", $b/1024);
 return $b." bytes";
}

function calc_rate($b) {
 $g=(int)($b/(1024*1024*1024)); /* GB */
 $m=(int)($b/(1024*1024)); /* MB */
 $k=(int)($b/1024); /* KB */
 if ($g) return sprintf("%.2f GB/s", $b/(1024*1024*1024));
 if ($m) return sprintf("%.2f MB/s", $b/(1024*1024));
 if ($k) return sprintf("%.2f KB/s", $b/1024);
 return sprintf("%.2f B/s", $b);
}

/* parsing */
for ($line=0,$all_ones=0,$logfile=file($F_PPPD);isset($logfile[$line]);$line++) {
 $tmp[0]=$tmp[1]=$tmp[2]=$tmp[3]=0;
 $tmp=explode("#", $logfile[$line]);
 /* only if 3 # are here */
 if (!$tmp[0] || !$tmp[1] || !$tmp[2] || !$tmp[3]) continue;
 $entry=1; /* we have digits only ? */
 if (strcspn($tmp[0], "1234567890")>0) $entry=0;
 if (strcspn($tmp[1], "1234567890")>0) $entry=0;
 if (strcspn($tmp[2], "1234567890")>0) $entry=0;
 if (strcspn($tmp[3], "1234567890")>0) $entry=0;
 if ($entry) { /* yes, we have */
  $all_ones++;
  /* add them, to our arrays */
  $outTIME[]=$tmp[0];        /* logout @time*/
  $coTIME[]=$tmp[1];         /* time, we were connected */
  $sBYTES[]=$tmp[2];         /* send bytes */
  $rBYTES[]=$tmp[3];         /* recv bytes */
  $inTIME[]=$tmp[0]-$tmp[1]; /* when we got in */
 }
} /* EOF, for each line */

/* now, calc stats: */
$d_all_time=0; $d_all_send=0; $d_all_recv=0; /* daily stats */
$m_all_time=0; $m_all_send=0; $m_all_recv=0; /* monthly stats */
$w_all_time=0; $w_all_send=0; $w_all_recv=0; /* weekly stats */
$y_all_time=0; $y_all_send=0; $y_all_recv=0; /* yearly stats */
$t_all_time=0; $t_all_send=0; $t_all_recv=0; /* total stats */
$l_year=$l_month=$l_week=$l_day=0; /* last ones */

$th1=$msg[$lang]['pppd']['tableH1'];
$th2=$msg[$lang]['pppd']['tableH2'];
$th3=$msg[$lang]['pppd']['tableH3'];
$th4=$msg[$lang]['pppd']['tableH4'];
$th5=$msg[$lang]['pppd']['tableH5'];
$th6=$msg[$lang]['pppd']['tableH6'];
$th7=$msg[$lang]['pppd']['tableH7'];
$th8=$msg[$lang]['pppd']['tableH8'];

echo "
<table border=\"0\" width=\"100%\"><tr>
 <td bgcolor=\"$h_color\"><b>$th1</b></td>
 <td bgcolor=\"$h_color\" align=\"right\"><b>$th2</b></td>
 <td bgcolor=\"$h_color\" align=\"right\"><b>$th3</b></td>
 <td bgcolor=\"$h_color\" align=\"right\"><b>$th4</b></td>";
if ($want_in_rate)
echo "<td bgcolor=\"$h_color\" align=\"right\"><b>$th5</b></td>";
echo "<td bgcolor=\"$h_color\" align=\"right\"><b>$th6</b></td>";
if ($want_out_rate)
echo "<td bgcolor=\"$h_color\" align=\"right\"><b>$th7</b></td>";
echo "<td bgcolor=\"$h_color\" align=\"right\"><b>$th8</b></td></tr>";

$no_summary=1;
for ($entry=0;$entry<$all_ones;$entry++) {

 /* current entry times */
 $c_year= date("Y", $inTIME[$entry]);                  /* year counter */
 $c_month = $name_month[date("n", $inTIME[$entry])-1]; /* 0..11 (month) */
 $c_week=strftime("%V", $inTIME[$entry]);              /* week counter 1..53 */
 $c_day = date("d.m.Y", $inTIME[$entry]) ." (". $name_day[date("w", $inTIME[$entry])] .")"; /* 0-6 */

 /* we have to choose between year/month/week/day updates */
 if ($c_year!=$l_year) {$year=1;$month=1;$week=1;$day=1;}
 if ($c_year==$l_year && $c_month!=$l_month) {$month=1;$week=1;$day=1;}
 if ($c_year==$l_year && $c_month==$l_month && $c_week!=$l_week) {$week=1;$day=1;}
 if ($c_year==$l_year && $c_month==$l_month && $c_week==$l_week && $c_day!=$l_day) $day=1;

 if (isset($no_summary)) {
  $day=$week=$month=$year=0;
  unset($no_summary);
 }

 if ($day) {
  $day=0;
  $time=mkit_from_secs($d_all_time);
  if ($want_bytes) {
   $in=number_format($d_all_recv, 0, ",",".");
   $out=number_format($d_all_send, 0, ",",".");
   $in_out=number_format($d_all_send+$d_all_recv, 0, ",",".");
  } else {
   $in=calc_size($d_all_recv);
   $out=calc_size($d_all_send);
   $in_out=calc_size($d_all_recv+$d_all_send);;
  }
  $r_in=calc_rate($d_all_recv/$d_all_time);
  $r_out=calc_rate($d_all_send/$d_all_time);
  if ($want_daily) {
   echo "<tr>";
   echo "<td bgcolor=\"$d_color\" colspan=\"2\">$c_day</td>";
   echo "<td bgcolor=\"$d_color\" align=\"right\">$time</td>";
   echo "<td bgcolor=\"$d_color\" align=\"right\"><font color=\"$d_in_font\">$in</font></td>";
   if ($want_in_rate)
   echo "<td bgcolor=\"$d_color\" align=\"right\"><font color=\"$d_in_font\">$r_in</font></td>";
   echo "<td bgcolor=\"$d_color\" align=\"right\"><font color=\"$d_out_font\">$out</font></td>";
   if ($want_out_rate)
   echo "<td bgcolor=\"$d_color\" align=\"right\"><font color=\"$d_out_font\">$r_out</font></td>";
   echo "<td bgcolor=\"$d_color\" align=\"right\">$in_out</td></tr>";
  }
  $w_all_time+=$d_all_time; /* add them to weekly stats */
  $w_all_send+=$d_all_send;
  $w_all_recv+=$d_all_recv;
  $d_all_time=$d_all_send=$d_all_recv=0; /* reset daily stats */
 }

 /* calc stats from current login */
  $d_all_time+=$coTIME[$entry];
  $d_all_send+=$sBYTES[$entry];
  $d_all_recv+=$rBYTES[$entry];

 if ($week) {
  $week=0;
  $time=mkit_from_secs($w_all_time);
  if ($want_bytes) {
   $in=number_format($w_all_recv, 0, ",",".");
   $out=number_format($w_all_send, 0, ",",".");
   $in_out=number_format($w_all_send+$w_all_recv, 0, ",",".");
  } else {
   $in=calc_size($w_all_recv);
   $out=calc_size($w_all_send);
   $in_out=calc_size($w_all_recv+$w_all_send);;
  }
  $r_in=calc_rate($w_all_recv/$w_all_time);
  $r_out=calc_rate($w_all_send/$w_all_time);
  if ($want_weekly) {
   echo "<tr>";
   echo "<td bgcolor=\"$w_color\" colspan=\"2\"><i>$l_week. $w_name</i></td>";
   echo "<td bgcolor=\"$w_color\" align=\"right\">$time</td>";
   echo "<td bgcolor=\"$w_color\" align=\"right\"><font color=\"$w_in_font\">$in</font></td>";
   if ($want_in_rate)
   echo "<td bgcolor=\"$w_color\" align=\"right\"><font color=\"$w_in_font\">$r_in</font></td>";
   echo "<td bgcolor=\"$w_color\" align=\"right\"><font color=\"$w_out_font\">$out</font></td>";
   if ($want_out_rate)
   echo "<td bgcolor=\"$w_color\" align=\"right\"><font color=\"$w_out_font\">$r_out</font></td>";
   echo "<td bgcolor=\"$w_color\" align=\"right\">$in_out</td></tr>";
  }
  $m_all_time+=$w_all_time; /* add weekly to monthly stats */
  $m_all_send+=$w_all_send;
  $m_all_recv+=$w_all_recv;
  $w_all_time=$w_all_send=$w_all_recv=0; /* reset weekly stats */
 }

 /* print monthly stats */
 if ($month) {
  $month=0;
  $time=mkit_from_secs($m_all_time);
  if ($want_bytes) {
   $in=number_format($m_all_recv, 0, ",",".");
   $out=number_format($m_all_send, 0, ",",".");
   $in_out=number_format($m_all_send+$m_all_recv, 0, ",",".");
  } else {
   $in=calc_size($m_all_recv);
   $out=calc_size($m_all_send);
   $in_out=calc_size($m_all_send+$m_all_recv);
  }
   $r_in=calc_rate($m_all_recv/$m_all_time);
   $r_out=calc_rate($m_all_send/$m_all_time);
   if ($want_monthly) {
    echo "<tr>";
    echo "<td bgcolor=\"$m_color\" colspan=\"2\"><b>$l_month</b></td>";
    echo "<td bgcolor=\"$m_color\" align=\"right\">$time</td>";
    echo "<td bgcolor=\"$m_color\" align=\"right\"><font color=\"$m_in_font\">$in</font></td>";
    if ($want_in_rate)
    echo "<td bgcolor=\"$m_color\" align=\"right\"><font color=\"$m_in_font\">$r_in</font></td>";
    echo "<td bgcolor=\"$m_color\" align=\"right\"><font color=\"$m_out_font\">$out</font></td>";
    if ($want_out_rate)
    echo "<td bgcolor=\"$m_color\" align=\"right\"><font color=\"$m_out_font\">$r_out</font></td>";
    echo "<td bgcolor=\"$m_color\" align=\"right\">$in_out</td></tr>";
  }
  $y_all_time+=$m_all_time; /* add them to yearly stats */
  $y_all_send+=$m_all_send;
  $y_all_recv+=$m_all_recv;
  $m_all_time=$m_all_send=$m_all_recv=0; /* reset monthly stats */
 }

 /* print yaerly stats */
 if ($year) {
  $year=0;
  $time=mkit_from_secs($y_all_time);
  if ($want_bytes) {
   $in=number_format($y_all_recv, 0, ",",".");
   $out=number_format($y_all_send, 0, ",",".");
   $in_out=number_format($y_all_send+$y_all_recv, 0, ",",".");
  } else {
   $in=calc_size($y_all_recv);
   $out=calc_size($y_all_send);
   $in_out=calc_size($y_all_send+$y_all_recv);
  }
  $r_in=calc_rate($y_all_recv/$y_all_time);
  $r_out=calc_rate($y_all_send/$y_all_time);
  if ($want_yearly) {
   echo "<tr>";
   echo "<td bgcolor=\"$y_color\" colspan=\"2\"><b>$y_name $l_year</b></td>";
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b>$time</b></td>";
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b><font color=\"$y_in_font\">$in</font></b></td>";
   if ($want_in_rate)
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b><font color=\"$y_in_font\">$r_in</font></b></td>";
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b><font color=\"$y_out_font\">$out</font></b></td>";
   if ($want_out_rate)
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b><font color=\"$y_out_font\">$r_out</font></b></td>";
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b>$in_out</b></td></tr>";
  }
  $t_all_time+=$y_all_time; /* add them to total stats */
  $t_all_send+=$y_all_send;
  $t_all_recv+=$y_all_recv;
  $y_all_time=$y_all_send=$y_all_recv=0; /* reset yearly stats */
 }

 /* print login stats (always) */
  $from_to=date("H:i:s", $inTIME[$entry]) . " - " . date("H:i:s", $outTIME[$entry]);
  $time=mkit_from_secs($coTIME[$entry]);

  if ($want_bytes) {
   $in= number_format($rBYTES[$entry],0, ",",".");
   $out= number_format($sBYTES[$entry],0, ",",".");
   $in_out= number_format($sBYTES[$entry]+$rBYTES[$entry],0, ",",".");
  } else {
   $in=calc_size($rBYTES[$entry]);
   $out=calc_size($sBYTES[$entry]);
   $in_out=calc_size($sBYTES[$entry]+$rBYTES[$entry]);
  }
  $r_in=calc_rate($rBYTES[$entry]/$coTIME[$entry]);
  $r_out=calc_rate($sBYTES[$entry]/$coTIME[$entry]);
  if ($want_logins) {
   echo "<tr>";
   echo "<td>&nbsp;</td>";
   echo "<td bgcolor=\"$l_color\" align=\"right\">$from_to</td>";
   echo "<td bgcolor=\"$l_color\" align=\"right\">$time</td>";
   echo "<td bgcolor=\"$l_color\" align=\"right\"><font color=\"$l_in_font\">$in</font></td>";
   if ($want_in_rate)
   echo "<td bgcolor=\"$l_color\" align=\"right\"><font color=\"$l_in_font\">$r_in</font></td>";
   echo "<td bgcolor=\"$l_color\" align=\"right\"><font color=\"$l_out_font\">$out</font></td>";
   if ($want_out_rate)
   echo "<td bgcolor=\"$l_color\" align=\"right\"><font color=\"$l_out_font\">$r_out</font></td>";
   echo "<td bgcolor=\"$l_color\" align=\"right\">$in_out</td></tr>";
  }

  /* last one ist now current */
  $l_year=$c_year; $l_month=$c_month; $l_week=$c_week; $l_day=$c_day;
} /* EOF for(entrys) */

  $day=0;
  $time=mkit_from_secs($d_all_time);
  if ($want_bytes) {
   $in=number_format($d_all_recv, 0, ",",".");
   $out=number_format($d_all_send, 0, ",",".");
   $in_out=number_format($d_all_send+$d_all_recv, 0, ",",".");
  } else {
   $in=calc_size($d_all_recv);
   $out=calc_size($d_all_send);
   $in_out=calc_size($d_all_recv+$d_all_send);;
  }
  $r_in=calc_rate($d_all_recv/$d_all_time);
  $r_out=calc_rate($d_all_send/$d_all_time);
  if ($want_daily) {
   echo "<tr>";
   echo "<td bgcolor=\"$d_color\" colspan=\"2\">$l_day</td>";
   echo "<td bgcolor=\"$d_color\" align=\"right\">$time</td>";
   echo "<td bgcolor=\"$d_color\" align=\"right\"><font color=\"$d_in_font\">$in</font></td>";
   if ($want_in_rate)
   echo "<td bgcolor=\"$d_color\" align=\"right\"><font color=\"$d_in_font\">$r_in</font></td>";
   echo "<td bgcolor=\"$d_color\" align=\"right\"><font color=\"$d_out_font\">$out</font></td>";
   if ($want_out_rate)
   echo "<td bgcolor=\"$d_color\" align=\"right\"><font color=\"$d_out_font\">$r_out</font></td>";
   echo "<td bgcolor=\"$d_color\" align=\"right\">$in_out</td></tr>";
  }
  $w_all_time+=$d_all_time; /* add them to weekly stats */
  $w_all_send+=$d_all_send;
  $w_all_recv+=$d_all_recv;
  $d_all_time=$d_all_send=$d_all_recv=0; /* reset daily stats */

 /* calc stats from current login */
  $d_all_time+=$coTIME[$entry];
  $d_all_send+=$sBYTES[$entry];
  $d_all_recv+=$rBYTES[$entry];

  $week=0;
  $time=mkit_from_secs($w_all_time);
  if ($want_bytes) {
   $in=number_format($w_all_recv, 0, ",",".");
   $out=number_format($w_all_send, 0, ",",".");
   $in_out=number_format($w_all_send+$w_all_recv, 0, ",",".");
  } else {
   $in=calc_size($w_all_recv);
   $out=calc_size($w_all_send);
   $in_out=calc_size($w_all_recv+$w_all_send);;
  }
  $r_in=calc_rate($w_all_recv/$w_all_time);
  $r_out=calc_rate($w_all_send/$w_all_time);
  if ($want_weekly) {
   echo "<tr>";
   echo "<td bgcolor=\"$w_color\" colspan=\"2\"><i>$l_week. $w_name</i></td>";
   echo "<td bgcolor=\"$w_color\" align=\"right\">$time</td>";
   echo "<td bgcolor=\"$w_color\" align=\"right\"><font color=\"$w_in_font\">$in</font></td>";
   if ($want_in_rate)
   echo "<td bgcolor=\"$w_color\" align=\"right\"><font color=\"$w_in_font\">$r_in</font></td>";
   echo "<td bgcolor=\"$w_color\" align=\"right\"><font color=\"$w_out_font\">$out</font></td>";
   if ($want_out_rate)
   echo "<td bgcolor=\"$w_color\" align=\"right\"><font color=\"$w_out_font\">$r_out</font></td>";
   echo "<td bgcolor=\"$w_color\" align=\"right\">$in_out</td></tr>";
  }
  $m_all_time+=$w_all_time; /* add weekly to monthly stats */
  $m_all_send+=$w_all_send;
  $m_all_recv+=$w_all_recv;
  $w_all_time=$w_all_send=$w_all_recv=0; /* reset weekly stats */

 /* print monthly stats */
  $month=0;
  $time=mkit_from_secs($m_all_time);
  if ($want_bytes) {
   $in=number_format($m_all_recv, 0, ",",".");
   $out=number_format($m_all_send, 0, ",",".");
   $in_out=number_format($m_all_send+$m_all_recv, 0, ",",".");
  } else {
   $in=calc_size($m_all_recv);
   $out=calc_size($m_all_send);
   $in_out=calc_size($m_all_send+$m_all_recv);
  }
   $r_in=calc_rate($m_all_recv/$m_all_time);
   $r_out=calc_rate($m_all_send/$m_all_time);
   if ($want_monthly) {
    echo "<tr>";
    echo "<td bgcolor=\"$m_color\" colspan=\"2\"><b>$l_month</b></td>";
    echo "<td bgcolor=\"$m_color\" align=\"right\">$time</td>";
    echo "<td bgcolor=\"$m_color\" align=\"right\"><font color=\"$m_in_font\">$in</font></td>";
    if ($want_in_rate)
    echo "<td bgcolor=\"$m_color\" align=\"right\"><font color=\"$m_in_font\">$r_in</font></td>";
    echo "<td bgcolor=\"$m_color\" align=\"right\"><font color=\"$m_out_font\">$out</font></td>";
    if ($want_out_rate)
    echo "<td bgcolor=\"$m_color\" align=\"right\"><font color=\"$m_out_font\">$r_out</font></td>";
    echo "<td bgcolor=\"$m_color\" align=\"right\">$in_out</td></tr>";
  }
  $y_all_time+=$m_all_time; /* add them to yearly stats */
  $y_all_send+=$m_all_send;
  $y_all_recv+=$m_all_recv;
  $m_all_time=$m_all_send=$m_all_recv=0; /* reset monthly stats */

 /* print yearly stats */
  $time=mkit_from_secs($y_all_time);
  if ($want_bytes) {
   $in=number_format($y_all_recv, 0, ",",".");
   $out=number_format($y_all_send, 0, ",",".");
   $in_out=number_format($y_all_send+$y_all_recv, 0, ",",".");
  } else {
   $in=calc_size($y_all_recv);
   $out=calc_size($y_all_send);
   $in_out=calc_size($y_all_send+$y_all_recv);
  }
  $r_in=calc_rate($y_all_recv/$y_all_time);
  $r_out=calc_rate($y_all_send/$y_all_time);
  if ($want_yearly) {
   echo "<tr>";
   echo "<td bgcolor=\"$y_color\" colspan=\"2\"><b>$y_name $l_year</b></td>";
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b>$time</b></td>";
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b><font color=\"$y_in_font\">$in</font></b></td>";
   if ($want_in_rate)
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b><font color=\"$y_in_font\">$r_in</font></b></td>";
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b><font color=\"$y_out_font\">$out</font></b></td>";
   if ($want_out_rate)
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b><font color=\"$y_out_font\">$r_out</font></b></td>";
   echo "<td bgcolor=\"$y_color\" align=\"right\"><b>$in_out</b></td></tr>";
  }
  $t_all_time+=$y_all_time; /* add them to total stats */
  $t_all_send+=$y_all_send;
  $t_all_recv+=$y_all_recv;
  $y_all_time=$y_all_send=$y_all_recv=0; /* reset yearly stats */

$time=mkit_from_secs($t_all_time);
if ($want_bytes) {
 $in=number_format($t_all_recv, 0, ",",".");
 $out=number_format($t_all_send, 0, ",",".");
 $in_out=number_format($t_all_send+$t_all_recv, 0, ",",".");
} else {
 $in=calc_size($t_all_recv);
 $out=calc_size($t_all_send);
 $in_out=calc_size($t_all_send+$t_all_recv);
}
if ($want_total) {
 echo "<tr>";
 echo "<td bgcolor=\"$t_color\" colspan=\"2\"><b>$th8:</b></td>";
 echo "<td bgcolor=\"$t_color\" align=\"right\"><b>$time</b></td>";
 echo "<td bgcolor=\"$t_color\" align=\"right\"><b><font color=\"$t_in_font\">$in</font></b></td>";
 if ($want_in_rate)
 echo "<td bgcolor=\"$t_color\" align=\"right\"><b><font color=\"$t_in_font\">$r_in</font></b></td>";
 echo "<td bgcolor=\"$t_color\" align=\"right\"><b><font color=\"$t_out_font\">$out</font></b></td>";
 if ($want_out_rate)
 echo "<td bgcolor=\"$t_color\" align=\"right\"><b><font color=\"$t_out_font\">$r_out</font></b></td>";
 echo "<td bgcolor=\"$t_color\" align=\"right\"><b>$in_out</b></td>";
 echo "</tr>";
}
echo "</table>";

?>
